/*
dauntless.cpp

(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/

#include "stdafx.h"
#include "gameIncludes.h"
#include "sea.h" 



//GLOBALS
mainGM_c mainGM;


timer_c timEr;

bool showCorners=false; 
bool sw_borders=false;

int frameNo=0;



//CdebugPoint mergeDBP[2];
//********************************************************************
//CLASSES

//GAMEMODES
/*
class landScaper_main:public gameMode
 {
	public:
		void mainLoop(void);
		void draw(void);
		void init(void);
		void shutdown(void);

	private:
		float timer;
		int wizardNum;
};
*/

mainGM_c::mainGM_c()
{
	ID=0;

	wind=1;
	desiredWind=1;
	orbitalCam=&screen.defaultVP;
	player[NULL];
	camYoffset=0;
	userWizardNo=0;
	displayHelp=false;
	oldNumChars=0;

	debugPhysics=false;
	double clearTimer=1000;
	bool clearTimerb=true;
}

mainGM_c::~mainGM_c()
{
	delete sea;
	sea=NULL;
}

void mainGM_c::mainLoop(void)
{
	int a;

//	setsockopt() - TCP_NODELAY



	//if this machine doesn't send this message, it causes a
	//slowdown in receiving the other machine's movements,
	//why, I do not know
	/*
	int rv;

	if (client.connected)
	{
		if (moved)
		{
			rv=cmd_setPlayerPos(client.sock,ID,&player[ID]);
			if (rv==SOCKET_ERROR)
				translateError();
		}

		else 
			rv=cmd_keepAlive(client.sock);
	}*/

//	if (!moved) outText(100,100,"Not moved");
	landscape.clearLights();
	
	if (!displayHelp)
	{
		switch (mode)
		{
			case MODE_GAME:
//				Sleep(30);		
				if (multiplayerGame) client.doStuff();
				if (multiplayerGame && !client.isConnected())
				{
					client.waitForPlayers.mainLoop();
				}
				else
				{
					doClearScreen();
					input();
					for (a=0;a<2;++a)
					{
						player[a]->doStuff();
					}
					for (a=0;a<2;++a)
					{
						wizard[a].doStuff();
					}
				}
			break;
			case MODE_INTRO:
				intro.mainLoop();
			break;
		}
	}
	else 
	{
		help.doStuff();
	}
			

	spellManager.doSpells();
	colCameraToLand();
	glPushMatrix();
		screen.defaultVP.setViewMatrix();
		viewFrustum.extract();
	glPopMatrix();

	sea->doStuff(viewFrustum);
	gParticles.move();

/*
	for (a=0;a<2;++a)
	{
		wizard[a].updatePos();
	}
*/
    physics.doPhysics();



	ambientSound();
	checkForRespawn();
}

void mainGM_c::input()
{
	static bool infoMode=false;
	static int meshSelect=0;
	static int triSelect=0;
	static int verSelect=0;
	static float speed=0;
	static bool SplitScreen=false;
	static int packetNo=0;
	static bool initMoved=true;
	static bool wireframe=false;
	static bool lightFollow=false;
	bool moved=initMoved;

//	char sendStr[8];
	TQuaternion oldQuat={1,0,0,0};
	float oldPos[3]={0,0,0};

	static bool lightOn=false;

	double sx,sy,sz;

	static int pType=0;

	if (keyJustPressed(DIK_F2))
	{
		client.disconnect();
	}

	if (keyJustPressed(DIK_F1))
	{
		displayHelp=true;
	}

	if (keyJustPressed(DIK_Y))
	{
		currentVP->setViewMatrix();
		currentVP->unproject(mouse.getX(),mouse.getY(),&sx,&sy,&sz);
		glPrintf("%f %f %f",sx,sy,sz);
	}
	
	if (keyJustPressed(DIK_E))
	{
		/*
		profiler.start();
		for (int a=0;a<32;++a)
		{
			landscape.drawQuicksand(50,50,50,0);
		}
		
		glPrintf("time elapsed: %f",profiler.getElapsed());
		//++pType;
		//if (pType==5) pType=0;
		//glCls();
		//Printf("ptype %d\n",pType);
		//landscape.getBaseTex()->save.copyFrom(composite);
		*/
		glPrintf("attempting to send something:\n");
		//client.sendMulticastIP();
		client.sendMessage(CMD_DEBUG);

	}

	if (keyJustPressed(DIK_U))
	{
//		messageBox("saving image");
//		landscape.getBaseTex()->save.saveBMP("COMPOSITE.BMP");

	}



/*
	float values[5]={253,120,2,4,24};
	float valuesb[5]={253,120,2,4,24};
	float destValues[5];
	int order[5];
	int otherOrder[5];

	if (keyJustPressed(DIK_I))
	{
		radixSort(values,5,order,otherOrder,destValues);
		glPrintf("Radix sort test\n");
		glPrintf("Input      Output\n");
		for (int a=0;a<5;++a)
		{
			glPrintf("%f %f  %f %f\n",values[a],destValues[a],valuesb[otherOrder[a]],valuesb[order[a]]);
		}
	}

*/


//	mouse.display();
	//do the wind
	if (desiredWind!=wind)
	{
		if (desiredWind>wind)
		{
			wind+=0.01*speedmod;
		}
		else
		{
			wind-=0.01*speedmod;
		}
		if (fabs(desiredWind-wind)<0.01) wind=desiredWind;
	}

	if (keyJustPressed(DIK_I))
	{
//		sea->doStuff(viewFrustum);
		glPrintf("Physics : %d\n",physics.toggle());
	}

	if (keyJustPressed(DIK_O))
	{
		debugPhysics=!debugPhysics;

		glPrintf("Debug Physics : %d\n",debugPhysics);
	}

	sea->setWindFactor(wind);
 
//	CNetCommand c;
/*
	if (keyJustPressed(DIK_3))
	{
		cmd_chat(client.sock,mainGM.ID,0,"HELLO SERVER");

	}
	if (keyJustPressed(DIK_4))
	{
		cmd_chat(client.sock,mainGM.ID,-1,"HELLO ALL");

	}

	if (keyJustPressed(DIK_5))
	{
		cmd_chat(client.sock,mainGM.ID,mainGM.ID,"HELLO ME");
	}
*/
	static bool displayfps=false;
	static int benchCount=0;
	static float totalTime=0;

	/*
	void walk();
	void stop();
	void turn(int angle);
	void die();
	void drown();
	*/
	
	if (keyJustPressed(DIK_F))
	{
		displayfps=!displayfps;
		benchCount=0;
	}

	if (displayfps)
	{
		if (benchCount>50)
		{
			glCls();
			glPrintf("%d fps",(int)(5000.0/totalTime));
			benchCount=0;
			totalTime=0;
		}
		totalTime+=speedmod;
		++benchCount;
	}



	if (keyJustPressed(DIK_8))
	{
		glPrintf("lighton %d",lightOn);
		lightOn=!lightOn;

	}

/*
	timer_c profiler;

	if (lightOn)
	{
		//double mx,my,mz;
		//currentVP->setViewMatrix();
		//currentVP->unproject(mouse.getX(),mouse.getY(),&mx,&my,&mz);

//		landscape.drawLight(mx,my,mz);

		double timeElapsed;
		profiler.start();

		for (int a=0;a<100;++a) landscape.drawLight(50,50,10,0.5);

		timeElapsed=profiler.getElapsed();
		glCls();
		glPrintf("%lf elapsed\n",timeElapsed);
		
//		landscape.drawLight(60,50,10);
	}
*/
	if (keyJustPressed(DIK_P))
	{
		glPrintf("Game paused. Press any key");
		pause();
		
	}

	if (keyJustPressed(DIK_W))
	{
		wireframe=!wireframe;
		if (wireframe)
		{
			glPolygonMode(GL_FRONT,GL_LINE);
		}
		else
		{
			glPolygonMode(GL_FRONT,GL_FILL);
		}
	}

	if (keyJustPressed(DIK_R))
	{
		initMoved=!initMoved;
		glPrintf("initMoved=%d",initMoved);
	} 


	cameraInput();



	/*
	if (keyDown(DIK_C))
	{
		moved=true;
		currentVP->rotate(2,-speedmod);
	}
	if (keyDown(DIK_V))
	{
		moved=true;
		currentVP->rotate(2,speedmod);
	}
	if (keyDown(DIK_S))
	{
		moved=true;
		speed+=1*speedmod;
		if (speed>3) speed=3;
	}
	if (keyDown(DIK_X))
	{
		moved=true;
		speed-=1*speedmod;
		if (speed<0) speed=0;
	}
	if (keyDown(DIK_LEFT))
	{
		moved=true;
		//currentVP->rot[1]+=1*speedmod;
		currentVP->rotate(1,-1*speedmod);
	}
	if (keyDown(DIK_RIGHT))
	{
		moved=true;
		//currentVP->rot[1]-=1*speedmod;
		currentVP->rotate(1,1*speedmod);
	}
	if (keyDown(DIK_UP))
	{
		moved=true;
		//currentVP->rot[0]+=1*speedmod;
		currentVP->rotate(0,-1*speedmod);
	}
	if (keyDown(DIK_DOWN))
	{
		moved=true;
		//currentVP->rot[0]-=1*speedmod;
		currentVP->rotate(0,1*speedmod);
	}

	if (keyDown(DIK_A))
	{
		moved=true;
		//anglesToCoord(currentVP->rot,0.5*speedmod,movevect);
//		for (a=0;a<3;++a)
//		{
//			currentVP->pos[a]+=currentVP->axis[2][a];//*speedmod;

		//	currentVP->pos[a]-=movevect[a];
//		}
		currentVP->move(2,-1*speedmod);
	}
	if (keyDown(DIK_Z))
	{
		moved=true;
//		anglesToCoord(currentVP->rot,0.5*speedmod,movevect);
//		for (a=0;a<3;++a)
//		{
//			currentVP->pos[a]+=movevect[a];
//			currentVP->pos[a]-=0.5*currentVP->axis[2][a]*speedmod;
//		}
		currentVP->move(2,1*speedmod);
		//currentVP->pos[0]-=1*speedmod;
	}*/
	if (keyJustPressed(DIK_ESCAPE))
	{
//		Quit=1;
		mainMenu.execute();
	}
	if (keyJustPressed(DIK_L))
	{

		lightFollow=!lightFollow;
		
		//gllight
	}

	if (lightFollow)
	{
		lightpos[3]=1;
		float cPos[3];
		currentVP->getCameraPos(cPos);


		for (int a=0;a<3;++a)
		{
			lightpos[a]=cPos[a];
//			particle[0].pos[a]=cPos[a];
		}
	}

/*
	if (keyJustPressed(DIK_N))
	{
		for (a=0;a<forum.getMesh(1)->numTris;++a)
			glPrintf("%d %f %f %f\n",a,
				forum.getMesh(1)->tri[a].verNorm[0][0],
				forum.getMesh(1)->tri[a].verNorm[0][1],
				forum.getMesh(1)->tri[a].verNorm[0][2]);
			
	}
*/
	if (keyJustPressed(DIK_M))
	{
		glPushMatrix();
	}

/*
	if (keyJustPressed(DIK_D))
	{
		forum.getMesh(meshDel)->drawb=0;
		glPrintf("Mesh deleted: \n%d",meshDel);
		--meshDel;
	}
	*/
	if (keyJustPressed(DIK_T))
	{
		glCls();
	}

	if (keyJustPressed(DIK_I))
	{
		infoMode=!infoMode;
		if (infoMode) glPrintf("Info mode on\n\n");
		else glPrintf("Info mode off\n\n");
	}
	/*
	if (speed>0) moved=true;
	currentVP->move(2,-speed*speedmod);
	*/

}

void mainGM_c::draw(void)
{

	++frameNo;

	float blah[3]={0,0,0};
	
	glLightfv(GL_LIGHT0, GL_POSITION, lightpos);

	float lightpos2[4]={10,10,10,1};
	float white[4]={1,1,1,1};
	//glLightfv(GL_LIGHT1, GL_POSITION, lightpos2);
//	lights->getLight(0)->specify();
	lights.specifyAll();

	if (sky.isEnabled()) sky.draw();

	BoundingSphere sphere;
	sea->animate();


	if (mode!=MODE_INTRO)
	{
		wizard[0].draw();
		wizard[1].draw();
	}

	glColor3f(1,1,1);
	glPushMatrix();
	
		glTranslatef(0,20,0);
		trees.draw();
	glPopMatrix();
	glColor3f(1,1,1);

	if (debugPhysics) physics.debugDisplay();




	glPushMatrix();
		landscape.draw();
		sea->draw();
	glPopMatrix();

	spellManager.drawSpells();

	float camPos[3];
	currentVP->getCameraPos(camPos);
	float camNorm[3]={1,0,0};
	currentVP->getCameraNorm(camNorm);

	switch(mode)
	{
		case MODE_GAME:
			infoDisplay.display(wizard,userWizardNo,score);
		break;
		case MODE_INTRO:
			intro.draw();
		break;
	}
	gParticles.draw(camPos,camNorm);

	//switch modes here
	if (nextMode!=mode) changeToMode(nextMode);

	if (displayHelp)
	{
		help.display();
	}

	if (multiplayerGame && !client.isConnected() && currentMenu==NULL)
	{
		client.waitForPlayers.draw();
	}


}

void mainGM_c::colCameraToLand()
{
	float camPos[3];

	screen.defaultVP.getCameraPos(camPos);
	float minHeight=landscape.getYAt(camPos[0],camPos[2]);

	camYoffset=(minHeight+10)-camPos[1];

	//keep the camera above the land
	if (camYoffset>0)
	{
		screen.defaultVP.pos[1]+=camYoffset;
	}
	else camYoffset=0;
}

void mainGM_c::cameraInput()
{
	int movex,movey;
	static float desiredRot[2]={45,45};
	static float desiredRadius=100;
	static int oldPosx=320,oldPosy=240;
	float difx,dify;

	if (mouse.getRButtonClicked())
	{
		oldPosx=mouse.getX();
		oldPosy=mouse.getY(); 
		mouse.setPos(320,240); 
		mouse.hideCursor();
	}
	//camera movement:
	if (mouse.getRButtonDown())
	{
		if (invertMousex)
		{
			movex=-(mouse.getX()-320);
		}
		else
		{
			movex=mouse.getX()-320;
		}
		if (invertMousey)
		{
			movey=-(mouse.getY()-240);
		}
		else
		{
			movey=mouse.getY()-240;
		}

		mouse.setPos(320,240); 

		
		desiredRot[1]-=speedmod*movex*0.4;
		desiredRot[0]+=speedmod*movey*0.4;

		/*
		if (desiredRot[0]>182 || desiredRot[0]<-178) desiredRot[0]=-178;
		if (desiredRot[0]<-2) desiredRot[0]=-2;
*/
		fixAngle(&desiredRot[1]);
		fixAngle(&desiredRot[0]);

		difx=angleSubtract(desiredRot[0],orbitalCam->rot[0]);
		dify=angleSubtract(desiredRot[1],orbitalCam->rot[1]);

		orbitalCam->rot[0]+=difx*0.3;
		orbitalCam->rot[1]+=dify*0.3;

		if (orbitalCam->rot[0]>178) 
		{
			orbitalCam->rot[0]=178;
			desiredRot[0]=178;
		}
		if (orbitalCam->rot[0]<2) 
		{
			orbitalCam->rot[0]=2;
			desiredRot[0]=2;
		}



		fixAngles(orbitalCam->rot);
		
	}

	if (mouse.getRButtonReleased())
	{
		mouse.setPos(oldPosx,oldPosy);
		mouse.showCursor();
	}
	
	//do mouse zoom
	if (mouse.getMouseWheelDir()==1)
	{
		desiredRadius-=speedmod*25;
		if (desiredRadius<30) desiredRadius=30;
	}

	else if (mouse.getMouseWheelDir()==-1)
	{
		desiredRadius+=speedmod*25;
		if (desiredRadius>500) desiredRadius=500;
	}
	
	if (keyDown(DIK_A))
	{
		orbitalCam->radius-=speedmod*4;

		if (orbitalCam->radius<30) orbitalCam->radius=30;
		desiredRadius=orbitalCam->radius;
	}
	if (keyDown(DIK_Z))
	{
		orbitalCam->radius+=speedmod*4;
		if (orbitalCam->radius>500) orbitalCam->radius=500;
		desiredRadius=orbitalCam->radius;
	}
	float radDif=desiredRadius-orbitalCam->radius;

	orbitalCam->radius+=radDif*0.3;
	
	
	/*
	if (keyDown(DIK_LEFT))
	{
		orbitalCam->rot[1]+=speedmod;
	}
	if (keyDown(DIK_RIGHT))
	{
		orbitalCam->rot[1]-=speedmod;
	}
	if (keyDown(DIK_UP))
	{
		orbitalCam->rot[0]+=speedmod;
		if (orbitalCam->rot[0]>90) orbitalCam->rot[0]=90;

	}
	if (keyDown(DIK_DOWN))
	{
		orbitalCam->rot[0]-=speedmod;
		if (orbitalCam->rot[0]<2) orbitalCam->rot[0]=2;
	}
	*/
}
 
void mainGM_c::newGame(bool multiplayer, int userWizardNo, float AISkill)
{
	getCam()->pos[1]=0;

	multiplayerGame=multiplayer;
	score[0]=0;
	score[1]=0;

	setMode(MODE_GAME);
	spellManager.reset();
	gParticles.reset();

	physics.reset();

	//reset the wizards
	wizard[0].reset(wizStartPos[0]);
	wizard[1].reset(wizStartPos[1]);

	createPhysicsObjects();



	//reset the players
	delete player[0];
	delete player[1];

	this->userWizardNo=userWizardNo;

	player[userWizardNo]=new UserPlayer;

	if (multiplayer)
	{
		//server
		player[1-userWizardNo]=new NetPlayer;
		UserPlayer * userPlayer=dynamic_cast<UserPlayer *> (player[userWizardNo]);
		NetPlayer * netPlayer=dynamic_cast<NetPlayer *> (player[1-userWizardNo]);

		player[0]->setWizard(&wizard[0]);
		player[1]->setWizard(&wizard[1]);

		if (userWizardNo==0)
		{
			if (client.init(true,netPlayer,userPlayer))
			{
				glPrintf("hosting game");
			}
			else
			{
				glPrintf("error joining game\n");
				glPrintf("multicast packets not supported?");
			}
		}
		else
		{
			if (client.init(false,netPlayer,userPlayer))
			{
				glPrintf("joining game");
			}
			else
			{
				glPrintf("error joining game\n");
				glPrintf("multicast packets not supported?");
			}
		}
		wizard[1-userWizardNo].setNetWiz(true);
	}
	else
	{
		player[1-userWizardNo]=new AIPlayer;
		dynamic_cast<AIPlayer *>(player[1-userWizardNo])->setSkill(AISkill);

		player[0]->setWizard(&wizard[0]);
		player[1]->setWizard(&wizard[1]);
	}

}	

void mainGM_c::init(void)
{ 
	//float amb[4]={0.6,0.6,0.6,1};
	//glLightModelfv(GL_LIGHT_MODEL_AMBIENT,amb);
/*
	float red[4]={1,0,0,1};
	glLightfv(GL_LIGHT1, GL_AMBIENT, red);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, red);
	glLightfv(GL_LIGHT1, GL_SPECULAR, red);
	glEnable(GL_LIGHT1);
*/
	
/*	bmTest=new bumpmaptest;
	emTest=new CEnvmapTest;
	emTest->init();*/

//	lights=new LightManager;
//	glDrawArrays()


	wizStartPos[0][0]=120;
	wizStartPos[0][1]=60;
	wizStartPos[0][2]=120;

	/*
	wizStartPos[1][0]=-100;
	wizStartPos[1][1]=60;
	wizStartPos[1][2]=-100;
	*/
	wizStartPos[1][0]=-100;
	wizStartPos[1][1]=60;
	wizStartPos[1][2]=-100;

	soundTimer=0;
	initSounds();
	infoDisplay.loadTextures();

	sea=new CSea(82);


	//ShowCursor(TRUE);
	mouse.loadGLCursor("textures//crosshair.bmp");
//	mouse.showCursor();
	initFastMaths();

	_chdir("objects");

	wizB3D.load("wizard.b3d");
//	wizB3D.init();
//	wizB3D.scale(0.06);
	wizB3D.scale(0.05);

	wizard[0].setB3D(&wizB3D);
	wizard[0].init(0,wizStartPos[0]);
	wizard[0].setEnemy(&wizard[1]);

	wizard[1].setB3D(&wizB3D);
	wizard[1].init(2,wizStartPos[1]);
	wizard[1].setEnemy(&wizard[0]);

	trees.load("trees.b3d");
	trees.setLowestColourComponent(0.1);


 	glCls();
	_chdir("..");

	CImage hmImage; 
	CImage texImage;
	CImage seaImage;

	//texImage.loadBMP("textures\\landscape\\basetex.bmp");
	if (hmImage.loadBMP("textures\\islandheightmap.bmp"))
	{
		if (!landscape.loadFromImage(hmImage))
		{
			messageBox("failed to load hm");
		}
		landscape.loadBaseTex("textures\\landscape\\basetex.bmp");


		if (sky.useCubemap)
		{
			sea->setTex(sky.getCubemap());
		}
		else
		{
			seaImage.loadBMP("textures\\sky\\skydome.bmp");
	//		sea->loadFromImage(hmImage);
			sea->loadTexImage(seaImage);
		}
		sea->setSky(&sky);

//		sea.set(82,82,128);
		sea->setDepth(20); 
		sea->loadDepthMap("textures\\depthmap.bmp");
		sea->loadSyncMap("textures\\waveSyncMap.bmp");
		sea->loadAlphaMap("textures\\seaAlphaMap.bmp");
		landscape.loadLightmap("textures\\landscape\\lightmap.bmp");
		landscape.loadSeabedTex("textures\\seabed.bmp");
	}
	else
	{
		messageBox("failed to load hm image");
	}

	//dynamic lightmap
	landscape.addLightMapLightImg("textures\\lights\\fireLight64.bmp");
	//quicksand map
	landscape.addBaseTexAlphaLight("textures\\quicksand\\quicksand.bmp",
							"textures\\quicksand\\quicksandAlpha.bmp");

	

	player[0]=new UserPlayer;
	player[1]=new AIPlayer;

	player[0]->setWizard(&wizard[0]);
	player[1]->setWizard(&wizard[1]);

	createPhysicsObjects();

	initParticles();

	themeTune.load("music\\wizard3.mid");
	changeToMode(MODE_INTRO);
}

void mainGM_c::initParticles()
{
	gParticles.setStandardTex(loadNewTexture("textures//particle32.bmp",TF_LML,TF_LML,BMP,LOADTEX_ALPHAMAP));
}


void mainGM_c::shutdown(void)
{
	ShowCursor(FALSE);

//	themeTune.stop();

	for (int a=0;a<2;++a)
	{
		if (player[a]!=NULL)
		{
			delete player[a];
			player[a]=NULL;
		}
	}
}


//********************************************************************


void loadObjects(void)
{
	_chdir("objects");
//	forum.loadASC("vase.asc");

	_chdir("..");
}

void loadTextures(void)
{
	_chdir("textures");

//	loadAlphaMap(0,"text.raw",TF_LML,TF_LML,256);

//	loadAlphaMap(1,"particle32.raw",TF_LML,TF_LML,32);

//	loadTexture(2,"bigtex.raw",TF_LML,TF_LML,512);
//	loadTexture(3,"stone1.raw",TF_LML,TF_LML,256);
	
//	loadTexture(4,"titlescreen.raw",TF_LML,TF_LML,256);

//	loadTexture(5,"choosewizard.raw",TF_L,TF_L,256);
//	loadTexture(6,"choosenumplayers.raw",TF_L,TF_L,256);
	
	_chdir("sky");
	/*
	loadTexture(7,"sky0.raw",TF_L,TF_L,256);
	loadTexture(8,"sky1.raw",TF_L,TF_L,256);
	loadTexture(9,"sky2.raw",TF_L,TF_L,256);
	loadTexture(10,"sky3.raw",TF_L,TF_L,256);
	loadTexture(11,"sky4.raw",TF_L,TF_L,256);
	loadTexture(12,"sky5.raw",TF_L,TF_L,256);
	*/
//	sky.loadTextures("sky*.bmp");
	sky.loadTextures("sky*.bmp");
	_chdir("..");
	
//	loadTexture(13,"sand.raw",TF_LML,TF_LML,256);
//	loadTexture(14,"road1.raw",TF_LML,TF_LML,256);
	_chdir("..");
}



void mainGM_c::checkForRespawn()
{
	if (respawnb) 
	{
		respawnTimer-=speedmod;
		if (respawnTimer<0)
		{
			respawn();
		}
	}
	else
	{
		bool rs=false;
		for (int a=0;a<2;++a)
		{
			if (!wizard[a].isAlive())
			{
				score[1-a]++;
				rs=true;
			}
		}
		if (rs)
		{
			sea->setDesiredDepth(20);
			respawnb=true;
			respawnTimer=500;
		}
	}

}

void mainGM_c::respawn()
{
	
	respawnb=false;
	spellManager.reset();
	gParticles.reset();

	for (int a=0;a<2;++a)
	{
		if (wizard[a].isAlive())
		{
			wizard[a].heal(0.3333); //give the victorious wizard some more health
		}
		else wizard[a].respawn(wizStartPos[a]);
	}
}


void landscaper_initialize(void)
{
//	int a;


	glPointSize(4);
//	sky.setTexture(7);
	loadTextures();
	loadObjects();

	ShowCursor(FALSE);

	changeMode(&mainGM);


//	glPrintf("\n 2 %d\n",ls.LODmesh.tile[0][0].tex);
}

void landscaper_shutdown(void)
{
	//fixme: make objects (and textures) self constucting/destructing classes

	ShowCursor(TRUE);
}


void mainGM_c::createTreePhysOb(float x,float y,float z)
{
	PhysPtr phys;
	y+=2.85;
	phys=physics.createObject(x,y,z, 4);
	phys->createChildren(3);
	phys->getChild(0)->setup(x, y+1, z, 4);
	phys->getChild(1)->setup(x,y+4.5,z, 3);
	phys->getChild(2)->setup(x,y+7,z, 2);
	phys->getDimensionsFromChildren();
}

void mainGM_c::createPhysicsObjects()
{
	//trees
//	PhysicsObject *phys;
	
	createTreePhysOb(-89.03, 28.1473, 4.51);

	createTreePhysOb(17.007, 26.744, -85.55);
	createTreePhysOb(42.40, 27.021, -58.98);
	createTreePhysOb(35.768, 27.491, -40.047);
	createTreePhysOb(-102, 27.50, 71.631);
	createTreePhysOb(1.03, 33.62, 119.705);
	createTreePhysOb(27.529, 37.33, 129.223);


	//small rock
	physics.createObject(-36.215,29.47,61.608,1);

	//large rock
	physics.createObject(-29,28.30,54.6,6.2);
	physics.createObject(-31.00,30.55,54.6,6.2);
	
}

void mainGM_c::initSounds()
{
	sounds[0]=loadNewSound("sounds\\thunder.wav",2);
	sounds[1]=loadNewSound("sounds\\oceano.wav",2);
	sounds[2]=loadNewSound("sounds\\rainLoop.wav",2);
	sounds[3]=loadNewSound("sounds\\windLoop.wav",2);
	sounds[4]=loadNewSound("sounds\\whoosh.wav",2);
	sounds[4]->setVolume(0.9);
	sounds[5]=loadNewSound("sounds\\explosion.wav",2);
	sounds[6]=loadNewSound("sounds\\waterbubs.wav",2);
	//sounds[6]->setVolume(0.9);
	sounds[7]=loadNewSound("sounds\\slide.wav",2);
}

void mainGM_c::ambientSound()
{
	soundTimer+=speedmod;
	if (soundTimer>700)
	{
		soundTimer=0;
//		sounds[1]->play();
//		sounds[1]->setVolume(0.1);
	}
}

//relays messages to AIs
void mainGM_c::AIMessage(int message, float pos[3])
{
	for (int a=0;a<2;++a)
	{
		if (player[a]->getType()==PLAYER_AI)
		{
			AIPlayer * ai=dynamic_cast<AIPlayer *>(player[a]);

			//messageBox("message %d",message);
			ai->sendMessage(message,pos);
			
		}
	}
}


void mainGM_c::changeToMode(int nextMode)
{
	this->nextMode=nextMode;
	switch (nextMode)
	{
		case MODE_GAME:
			mouse.showCursor();
		break;
		case MODE_INTRO:
			intro.init();
		break;
	}
	mode=nextMode;
}

void mainGM_c::setInvertMousex(int val)
{
	invertMousex=(val==1);
}

void mainGM_c::setInvertMousey(int val)
{
	invertMousey=(val==1);
}


void mainGM_c::doClearScreen()
{
	clearTimer-=speedmod;
	if (oldNumChars!=numchars)
	{
		clearTimer=1000;
		oldNumChars=numchars;
	}
	else if (clearTimer<=0) 
	{
		clearTimer=1000;
		glCls();
	}

}

