// Extensions.h: interface for the Extensions class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EXTENSIONS_H__16075C45_A616_429A_8DE1_027C3C11C747__INCLUDED_)
#define AFX_EXTENSIONS_H__16075C45_A616_429A_8DE1_027C3C11C747__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "glExt.h"

//compiled vertex array
extern PFNGLLOCKARRAYSEXTPROC glLockArraysEXT;
extern PFNGLUNLOCKARRAYSEXTPROC glUnlockArraysEXT;

//NVIDIA register combiners
extern PFNGLCOMBINERPARAMETERFVNVPROC glCombinerParameterfvNV;
extern PFNGLCOMBINERPARAMETERFNVPROC glCombinerParameterfNV;
extern PFNGLCOMBINERPARAMETERIVNVPROC glCombinerParameterivNV;
extern PFNGLCOMBINERPARAMETERINVPROC glCombinerParameteriNV;
extern PFNGLCOMBINERINPUTNVPROC glCombinerInputNV;
extern PFNGLCOMBINEROUTPUTNVPROC glCombinerOutputNV;
extern PFNGLFINALCOMBINERINPUTNVPROC glFinalCombinerInputNV; //
extern PFNGLGETCOMBINERINPUTPARAMETERFVNVPROC glGetCombinerInputParameterfvNV; 
extern PFNGLGETCOMBINERINPUTPARAMETERIVNVPROC glGetCombinerInputParameterivNV; 
extern PFNGLGETCOMBINEROUTPUTPARAMETERFVNVPROC glGetCombinerOutputParameterfvNV;
extern PFNGLGETCOMBINEROUTPUTPARAMETERIVNVPROC glGetCombinerOutputParameterivNV;
extern PFNGLGETFINALCOMBINERINPUTPARAMETERFVNVPROC glGetFinalCombinerInputParameterfvNV;
extern PFNGLGETFINALCOMBINERINPUTPARAMETERIVNVPROC glGetFinalCombinerInputParameterivNV;

//ARB Multitexture Extensions 
extern PFNGLMULTITEXCOORD1DARBPROC		glMultiTexCoord1dARB; 
extern PFNGLMULTITEXCOORD1DVARBPROC	glMultiTexCoord1dvARB;	
extern PFNGLMULTITEXCOORD1FARBPROC		glMultiTexCoord1fARB;
extern PFNGLMULTITEXCOORD1FVARBPROC	glMultiTexCoord1fvARB;
extern PFNGLMULTITEXCOORD1IARBPROC		glMultiTexCoord1iARB;
extern PFNGLMULTITEXCOORD1IVARBPROC	glMultiTexCoord1ivARB;	
extern PFNGLMULTITEXCOORD1SARBPROC		glMultiTexCoord1sARB;
extern PFNGLMULTITEXCOORD1SVARBPROC	glMultiTexCoord1svARB;
extern PFNGLMULTITEXCOORD2DARBPROC		glMultiTexCoord2dARB;
extern PFNGLMULTITEXCOORD2DVARBPROC	glMultiTexCoord2dvARB;	
extern PFNGLMULTITEXCOORD2FARBPROC		glMultiTexCoord2fARB;
extern PFNGLMULTITEXCOORD2FVARBPROC	glMultiTexCoord2fvARB;
extern PFNGLMULTITEXCOORD2IARBPROC		glMultiTexCoord2iARB;
extern PFNGLMULTITEXCOORD2IVARBPROC	glMultiTexCoord2ivARB;
extern PFNGLMULTITEXCOORD2SARBPROC		glMultiTexCoord2sARB;
extern PFNGLMULTITEXCOORD2SVARBPROC	glMultiTexCoord2svARB;
extern PFNGLMULTITEXCOORD3DARBPROC		glMultiTexCoord3dARB;
extern PFNGLMULTITEXCOORD3DVARBPROC	glMultiTexCoord3dvARB;
extern PFNGLMULTITEXCOORD3FARBPROC		glMultiTexCoord3fARB;
extern PFNGLMULTITEXCOORD3FVARBPROC	glMultiTexCoord3fvARB;
extern PFNGLMULTITEXCOORD3IARBPROC		glMultiTexCoord3iARB;
extern PFNGLMULTITEXCOORD3IVARBPROC	glMultiTexCoord3ivARB;
extern PFNGLMULTITEXCOORD3SARBPROC		glMultiTexCoord3sARB;
extern PFNGLMULTITEXCOORD3SVARBPROC	glMultiTexCoord3svARB;
extern PFNGLMULTITEXCOORD4DARBPROC		glMultiTexCoord4dARB;
extern PFNGLMULTITEXCOORD4DVARBPROC	glMultiTexCoord4dvARB;	
extern PFNGLMULTITEXCOORD4FARBPROC		glMultiTexCoord4fARB;
extern PFNGLMULTITEXCOORD4FVARBPROC	glMultiTexCoord4fvARB;
extern PFNGLMULTITEXCOORD4IARBPROC		glMultiTexCoord4iARB;
extern PFNGLMULTITEXCOORD4IVARBPROC	glMultiTexCoord4ivARB; 
extern PFNGLMULTITEXCOORD4SARBPROC		glMultiTexCoord4sdARB;
extern PFNGLMULTITEXCOORD4SVARBPROC	glMultiTexCoord4svARB;
extern PFNGLACTIVETEXTUREARBPROC		glActiveTextureARB;
extern PFNGLCLIENTACTIVETEXTUREARBPROC	glClientActiveTextureARB;	

extern PFNGLSECONDARYCOLOR3BEXTPROC glSecondaryColor3bEXT;
extern PFNGLSECONDARYCOLOR3BVEXTPROC glSecondaryColor3bvEXT;
extern PFNGLSECONDARYCOLOR3DEXTPROC glSecondaryColor3dEXT;
extern PFNGLSECONDARYCOLOR3DVEXTPROC glSecondaryColor3dvEXT;
extern PFNGLSECONDARYCOLOR3FEXTPROC glSecondaryColor3fEXT;
extern PFNGLSECONDARYCOLOR3FVEXTPROC glSecondaryColor3fvEXT ;
extern PFNGLSECONDARYCOLOR3IEXTPROC glSecondaryColor3iEXT;
extern PFNGLSECONDARYCOLOR3IVEXTPROC glSecondaryColor3ivEXT;
extern PFNGLSECONDARYCOLOR3SEXTPROC glSecondaryColor3sEXT;
extern PFNGLSECONDARYCOLOR3SVEXTPROC glSecondaryColor3svEXT;
extern PFNGLSECONDARYCOLOR3UBEXTPROC glSecondaryColor3ubEXT;
extern PFNGLSECONDARYCOLOR3UBVEXTPROC glSecondaryColor3ubvEXT;
extern PFNGLSECONDARYCOLOR3UIEXTPROC glSecondaryColor3uiEXT;
extern PFNGLSECONDARYCOLOR3UIVEXTPROC glSecondaryColor3uivEXT;
extern PFNGLSECONDARYCOLOR3USEXTPROC glSecondaryColor3usEXT;
extern PFNGLSECONDARYCOLOR3USVEXTPROC glSecondaryColor3usvEXT;
extern PFNGLSECONDARYCOLORPOINTEREXTPROC glSecondaryColorPointerEXT;

//singleton extensions class
class CExtensions
{
public:
	CExtensions();
	~CExtensions();
	bool exists(const std::string & name);
	void getNames();
	void linkFunctions();
	void display();

	//extension linker functions
	bool initEXT_secondary_color();
	bool initARB_multitexture();
	bool initNV_register_combiners();
	bool initEXT_compiled_vertex_array();

private:
	std::string * extensionNames;
	int numExtensions;
} ; 

extern CExtensions extensions;


#endif // !defined(AFX_EXTENSIONS_H__16075C45_A616_429A_8DE1_027C3C11C747__INCLUDED_)
