/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
#include "fastMaths.h"
#include "stdafx.h"

float fastSinLookup[FASTSIN_RES];
float fastCosLookup[FASTSIN_RES];

void initFastMaths()
{
	initFastSin();
	initFastCos();
}

void initFastSin()
{
	for (int a=0;a<FASTSIN_RES;++a)
	{
		fastSinLookup[a]=sin((float)a*FASTSIN_GRAN);
	}
}

void initFastCos()
{
	for (int a=0;a<FASTSIN_RES;++a)
	{
		fastCosLookup[a]=cos((float)a*FASTSIN_GRAN);
	}
}
