// FireballSpell.h: interface for the FireballSpell class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FIREBALLSPELL_H__0604452B_A575_470E_A30D_FE1FC8021AF5__INCLUDED_)
#define AFX_FIREBALLSPELL_H__0604452B_A575_470E_A30D_FE1FC8021AF5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "Spell.h"
#include "ParticleFire.h"
#include "PhysicsSystem.h"
#include "Light.h"
#include "Wizard.h"


class FireballSpell : public Spell  
{
public:
	FireballSpell();
	FireballSpell(	float target[3],float launchpos[3],
					Wizard * caster, Wizard * enemy);
	~FireballSpell();
	void doStuff();
	void draw();
	void deleteSelf(){delete this;}



protected:
	ParticleFire * fireball;
	float vect[3];
	PhysPtr phys;
	float pos[3];
	Light * light;
	Wizard * caster;
	Wizard * enemy;
	Sound whooshSound;
	Sound explosionSound;

};

#endif // !defined(AFX_FIREBALLSPELL_H__0604452B_A575_470E_A30D_FE1FC8021AF5__INCLUDED_)
