// Hazard.h: interface for the Hazard class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HAZARD_H__3D57DAFD_0E65_4C1B_8313_27918FFE3601__INCLUDED_)
#define AFX_HAZARD_H__3D57DAFD_0E65_4C1B_8313_27918FFE3601__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Hazard
{
public:
	Hazard();
	virtual ~Hazard();
	Hazard(const Hazard &src){copyFrom(src);}
	const Hazard& operator=(const Hazard &src)
	{
		copyFrom(src);
		return *this;
	}
	void copyFrom(const Hazard &src)
	{
		radius=src.radius;
		pos[0]=src.pos[0];
		pos[1]=src.pos[1];
		pos[2]=src.pos[2];
		danger=src.danger;
	}
	float radius;
	float pos[3];
	float danger;
};

#endif // !defined(AFX_HAZARD_H__3D57DAFD_0E65_4C1B_8313_27918FFE3601__INCLUDED_)
