// Light.h: interface for the Light class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LIGHT_H__6F97CDB7_8013_476F_BB1F_537E728B3102__INCLUDED_)
#define AFX_LIGHT_H__6F97CDB7_8013_476F_BB1F_537E728B3102__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Light  
{
public:
	Light();
	virtual ~Light();
	void specify();
	void setPos(float pos_in[3]);
	void setGLLight(unsigned int GLlite_in);
	void setParamf(unsigned int name, float param);
	void setParamfv(unsigned int name, float * param);
	void setColour(float red, float green, float blue);
	void enable();
	void disable();
	bool enabled;
	
protected:
	unsigned int GLlite;
	float pos[4];
	float colour[4];

};

#endif // !defined(AFX_LIGHT_H__6F97CDB7_8013_476F_BB1F_537E728B3102__INCLUDED_)
