/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// NetClient.cpp: implementation of the NetClient class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NetClient.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


NetClient::NetClient()
{
	connected=false;
	debug=false;
	opened=false;
}



void NetClient::handleMsg(WPARAM wParam, LPARAM lParam)
{
	bool debug=false;

	if (client.debug) glPrintf("[handlemsg]");

	switch (WSAGETSELECTEVENT(lParam))
	{
		case FD_READ:
			if (client.debug) glPrintf("[FD_READ]");
			readCommand(wParam);

//			glPrintf("Message received (frame %d)",frameNo);
			
		break;
		case FD_WRITE:
			if (client.debug) glPrintf("[FD_WRITE]");
		break;
	}
}






bool NetClient::startMulticastIP()
{
	opened=true;
	int er;
	SOCKADDR_IN addrLocal;

	glPrintf("entering multiplayer game...\n");
	sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
	addrLocal.sin_family = AF_INET;

	char addr[14];
	getHostAddress(addr);
	//glPrintf("using local IP %s",addr);
	addrLocal.sin_family = AF_INET;
	addrLocal.sin_addr.s_addr = INADDR_ANY;
	addrLocal.sin_port = htons(4567); 
	//if (host)
	//{
		if(SOCKET_ERROR == bind(sock, (LPSOCKADDR)&addrLocal, 
							sizeof(struct sockaddr)))
		{
			glPrintf("Problem\n");
		}
		glPrintf("Broadcast socket bound\n");
	//}

	mreq.imr_multiaddr.s_addr = inet_addr("234.5.6.7");
	mreq.imr_interface.s_addr = INADDR_ANY;
	int nRet = setsockopt(sock, IPPROTO_IP, IP_ADD_MEMBERSHIP,
					  (char*)&mreq, sizeof(mreq));

	if (SOCKET_ERROR==nRet)
	{
		glPrintf("Error joining multicast group\n");
		translateError(nRet);
	}

	TTL=32; 
	setsockopt(sock, IPPROTO_IP, IP_MULTICAST_TTL,
			   (char *)&TTL, sizeof(TTL));

	if (SOCKET_ERROR==(WSAAsyncSelect (sock, ghWnd, WM_NWCLIENTMULTICAST, 
		(FD_READ | FD_WRITE))))
	{
		glPrintf("error with WSAAsyncSelect");
	}
	else
	{
		glPrintf("WSAAsyncSelect OK");
	}

	addrDest.sin_family = AF_INET;
	addrDest.sin_addr.s_addr = inet_addr("234.5.6.7");
	addrDest.sin_port = htons(4567);

	char szHi[128]="blah";

//	int er;
	if (SOCKET_ERROR==(er=sendto(sock,szHi,128,0,(struct sockaddr*)&addrDest,
			sizeof(addrDest))))
	{
		glPrintf("send error:\n");
		translateError(er);
	}
	else
	{
		glPrintf("send successful");
	}


/*	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);

	SOCKADDR_IN addrLocal;

	port=40593;
	addrLocal.sin_family = AF_INET;

	getHostAddress(addr);
	glPrintf("using local IP %s\n",addr);
	addrLocal.sin_addr.s_addr = inet_addr(addr);//INADDR_ANY;
	addrLocal.sin_port = htons(port); 
	int er;

	if (host)
	{
		if(SOCKET_ERROR == (er=bind(sock, (LPSOCKADDR)&addrLocal, 
								sizeof(struct sockaddr))))
		{
			return false;
		}
		else 
		{
			glPrintf("Broadcast socket bound\n");
		}
	}

	mreq.imr_multiaddr.s_addr = inet_addr("234.5.6.7");
	mreq.imr_interface.s_addr = inet_addr(addr);//INADDR_ANY;

	int nRet = setsockopt(sock, IPPROTO_IP, IP_ADD_MEMBERSHIP,
					  (char*)&mreq, sizeof(mreq));

	if (SOCKET_ERROR==nRet)
	{
		glPrintf("setsockopt failed");
		return false;
	}

	TTL=32; 
	setsockopt(sock, IPPROTO_IP, IP_MULTICAST_TTL,
			   (char *)&TTL, sizeof(TTL));

	if (SOCKET_ERROR==(WSAAsyncSelect (sock, ghWnd, WM_NWCLIENTMULTICAST, 
		(FD_READ | FD_WRITE))))
	{
		glPrintf("WASAASyncSelect failed");
		return false;
	}

//	sendMulticastIP();
	char szHi[128]="blah";

	//int er;
	if (SOCKET_ERROR==(er=sendto(sock,szHi,5,0,(struct sockaddr*)&addrDest,
\			sizeof(addrDest))))
	{
		glPrintf("send error:\n");
		translateError(er);
	}
	else
	{
		glPrintf("send successful");
	}*/
/*
	SOCKADDR_IN  addrDest;
	addrDest.sin_family = AF_INET;
	addrDest.sin_addr.s_addr = inet_addr("234.5.6.7");
	addrDest.sin_port = htons(40326);
	sendto(sock,"ServerIP",8,0,(struct sockaddr*)&addrDest,
			sizeof(addrDest));
*/
	return true;


}
void NetClient::handleMulticastMsg(WPARAM wParam,LPARAM lParam)
{
	glPrintf("client multicast msg\n");
}


void NetClient::shutdown()
{
	if (connected) 
	{
		client.sendMessage(CMD_DISCONNECT);
	}
	if (opened)
	{
		ip_mreq mreq;
		mreq.imr_multiaddr.s_addr = inet_addr("234.5.6.7");
		mreq.imr_interface.s_addr = INADDR_ANY;//inet_addr(addr);
		setsockopt(sock, IPPROTO_IP, IP_DROP_MEMBERSHIP,
						  (char*)&mreq, sizeof(mreq));

		closesocket(sock);
	}
}

void NetClient::sendMulticastIP()
{
	char szHi[128]="blah";
	szHi[0]=random(32+32);
	int er;
	if (SOCKET_ERROR==(er=sendto(sock,szHi,128,0,(struct sockaddr*)&addrDest,
			sizeof(addrDest))))
	{
		glPrintf("send error:\n");
		translateError(er);
	}
	else glPrintf("must have worked\n");
}
