// ParticleSystem.h: interface for the ParticleSystem class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARTICLESYSTEM_H__9D765595_C2BE_4490_A249_CA07AE5A224E__INCLUDED_)
#define AFX_PARTICLESYSTEM_H__9D765595_C2BE_4490_A249_CA07AE5A224E__INCLUDED_

#include "Particle1.h"
#include "ParticleTypes.h"
//#include "ParticleManager.h"

//typedef std::list<Particle>::iterator PartIt;

class ParticleSystem
{
public:
	ParticleSystem();
	virtual ~ParticleSystem();
//	ParticleSystem(const ParticleSystem & src);
//	const ParticleSystem& operator=(const ParticleSystem& src);
//	void copyFrom(const ParticleSystem &src);
	void allocate(int maxParticles_in);

	void move();
	virtual void postMove(){} 

	virtual void preDraw(){}
	void draw();
	int cullDeadParticles();

	//virtual void start(){}
	void stop(){exist=false;}

	bool exist;
	virtual bool isDead();

	Particle * getParticlep(int i){return &particles[i];}
	int getNumParts(){return numParticles;}
	

protected:

	void createParticle(	Particle & part, 
								float launchTime);

	void destroyParticle(int index);
	CTexture * tex;
	//std::vector<Particle> particles;
	Particle * particles;
	int numParticles;
	int maxParticles;
};

#endif // !defined(AFX_PARTICLESYSTEM_H__9D765595_C2BE_4490_A249_CA07AE5A224E__INCLUDED_)
