// ParticleTornado.h: interface for the ParticleTornado class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARTICLETORNADO_H__BF17B2F1_C739_43D6_9EC8_F6F1443433B5__INCLUDED_)
#define AFX_PARTICLETORNADO_H__BF17B2F1_C739_43D6_9EC8_F6F1443433B5__INCLUDED_


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ParticleSystem.h"
 
class ParticleTornado : public ParticleSystem
{
public:
	ParticleTornado(float x,float y,float z,float partsPerSec);
	virtual ~ParticleTornado();

	void postMove(); 
	void preDraw();
	void stop();
	bool isDead();
	void makeParticle(Particle &part);
	void setPos(float pos_in[3]){pos[0]=pos_in[0];pos[1]=pos_in[1];pos[2]=pos_in[2];}
	float * getPos(){return pos;}
	void setColour(float r,float g,float b){colour[0]=r;colour[1]=g;colour[2]=b;}

protected:
	float pos[3];
	float partsPerSec;
	bool active;
	double timeOffset;
	float startAngle;
	float oldPos[3];
	float colour[4];

};

#endif // !defined(AFX_PARTICLETORNADO_H__BF17B2F1_C739_43D6_9EC8_F6F1443433B5__INCLUDED_)
