/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// SaveImage.cpp: implementation of the SaveImage class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SaveImage.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SaveImage::SaveImage()
{

}

SaveImage::~SaveImage()
{

}

void SaveImage::writeToFileAlign(int align,FILE * f)
{
	//align=1;
	//fwrite((void *)data,1,memSize,f);
	int p=0;
	for (int y=0;y<height;++y)
	{
//		fwrite((void *)&data[y*width*numChannels],1,width*numChannels,f);
		for (int x=0;x<width;++x)
		{
			for (int a=numChannels-1;a>=0;--a) 
			{
				fputc(data[p+a],f);
			}
			p+=numChannels;
		}


		for (int a=0;a<align;++a)
		{
			fputc(0,f);
		}
		
	}
	
}

bool SaveImage::saveBMP(const char * filename)
{
	
	BMPHeader header(width,height,numChannels);
	printf("memSize %d",memSize);
	
	FILE * f;
	if (!(f=fopen(filename,"wb"))) return false;

	header.writeToFile(f);

	printf("align %d",header.getAlignBytes());

	writeToFileAlign(header.getAlignBytes(),f);
	/*
	BMPHeader header;
	FILE * f=fopen("blah.bmp","rb");


	header.readFromFile(f);

	printf("bitmapDataSize   : %d\n",header.bitmapDataSize);
	printf("bpp              : %d\n",header.bpp);
	printf("colours          : %d\n",header.colours);
	printf("compression      : %d\n",header.compression);
	printf("dataOffset       : %d\n",header.dataOffset);
	printf("fileSize         : %d\n",header.filesize);
	printf("headerSize       : %d\n",header.headerSize);
	printf("height           : %d\n",header.height);
	printf("hResPerMetre     : %d\n",header.hResPerMetre);
	printf("id               : %c%c\n",header.id[0],header.id[1]);
	printf("hResPerMetre     : %d\n",header.hResPerMetre);
	printf("importantColours : %d\n",header.importantColours);
	printf("planes           : %d\n",header.planes);
	printf("reserved         : %d\n",header.reserved);
	printf("vResPerMetre     : %d\n",header.vResPerMetre);
	printf("width            : %d\n",header.width);
*/
	
	fclose(f);
	return true;
}

void SaveImage::copyFrom(const CImage & src)
{
	messageBox("saveImage copyfrom");
	if (data!=NULL) delete [] data;
	allocate(src.width,src.height,src.numChannels);
	format=src.format;

	//copy the data
	for (int a=0;a<memSize;++a)
	{
		data[a]=src.data[a];
	}
}
