// SpellManager.h: interface for the SpellManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPELLMANAGER_H__FA9BB1DF_D178_4BED_9F26_A97BC231B74A__INCLUDED_)
#define AFX_SPELLMANAGER_H__FA9BB1DF_D178_4BED_9F26_A97BC231B74A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#define MAX_SPELLS 256

#include "Spell.h" 

typedef Spell * pSpell;
class SpellManager  
{
public:
	SpellManager();
	virtual ~SpellManager();
	void registerSpell(Spell * spell);
	void doSpells();
	void drawSpells();
	void clearSpells();
	void reset();

	//std::list <Spell *> spells;
	pSpell spells[MAX_SPELLS];
	int numSpells;
};

#endif // !defined(AFX_SPELLMANAGER_H__FA9BB1DF_D178_4BED_9F26_A97BC231B74A__INCLUDED_)
