// TornadoSpell.h: interface for the TornadoSpell class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TORNADOSPELL_H__9732CA4F_E20C_457B_A718_F7BCB20FE07E__INCLUDED_)
#define AFX_TORNADOSPELL_H__9732CA4F_E20C_457B_A718_F7BCB20FE07E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Spell.h"
#include "ParticleTornado.h"
#include "Wizard.h"

class TornadoSpell : public Spell  
{
public:
	TornadoSpell(float target[3], Wizard * caster, Wizard * enemy);
	~TornadoSpell();
	void doStuff();
	void deleteSelf(){delete this;}

protected:
	void moveWizards(Wizard * wizarda, Wizard * wizardb, float tforce);

	ParticleTornado * tornado;
	//ParticleFire * tornado;
	double timer;
	double decisionTimer;
	float vect[2];

	float pos[3];

	bool wizLock[2];
	Sound windSound;
	Wizard * caster;
	Wizard * enemy;

};

#endif // !defined(AFX_TORNADOSPELL_H__9732CA4F_E20C_457B_A718_F7BCB20FE07E__INCLUDED_)
