/*
Debuglog.cpp

v1.11

(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/

#include "debuglog.h"



void dateToString(char * stringp)
{
	struct tm *today;
	time_t ltime;

	time( &ltime );
	today = localtime( &ltime );

	strftime( stringp, 10,
	"%d/%m/%y", today );
}

debugLog_c::debugLog_c(char * fn)
{
//	bNode_c btree(maxval_in,minval_in,valuep,numvals);
	char sdate[128],stime[128];

    filename=new char[strlen(fn)+1];

    sprintf(filename,fn);

	file=fopen(fn,"wt");
	write("DebugLog file\n");
	dateToString(sdate);
	_strtime(stime);
	write("created: %s %s\n",sdate,stime);
	write("________________________________\n\n",sdate,stime);
}

debugLog_c::~debugLog_c()
{
    if (filename!=NULL) delete [] filename;
	fclose(file);
}

void debugLog_c::write(const char *format, ...)
{
	char buffer[128];
	//char test[20]={"debuglog test"};
	va_list args;
	//textDisplayList=0; //causes text display list to be updated

	va_start(args,format);
	vsprintf(buffer, format, args);
	va_end( args );

	fwrite(buffer,1,strlen(buffer),file);
}

void debugLog_c::update()
{
	fclose(file);
	file=fopen(filename,"at");
}
