/*
DirectInput.h
Version 1.41
(c)2000 Ben Woodhouse
*/


#define KEYDOWN(name,key) (name[key] & 0x80) 

#if     _MSC_VER > 1000
#pragma once
#endif

#ifndef _INC_DIRECTINPUT
#define _INC_DIRECTINPUT

#include <dinput.h>

//DEFINES
#define ALL 0
#define KEYBOARD_I 1
#define KEYBOARD_B 2
#define MOUSE_I 3

//GLOBALS
extern BYTE character;

extern LPDIRECTINPUT8 DI;
extern LPDIRECTINPUTDEVICE8 keyboardI; 
extern LPDIRECTINPUTDEVICE8 keyboardB; 
extern LPDIRECTINPUTDEVICE8 mouseI;
extern BYTE kbbufOLD[256]; 
extern BYTE kbbuf[256];
extern HRESULT ghr; //global hresult
extern BOOL DirectInputb; //becomes TRUE after DI is initialized
extern HWND DI_hWnd;

//FIXME: space causes crash
extern char DIKtoASCII[256];
extern char DIKtoASCII_shift[256];

//FUNCTIONS
bool keyDown(BYTE key);
bool keyJustPressed(BYTE key);
bool keyJustReleased(BYTE key);

void bitch(HRESULT hr);
BOOL DI_init(HWND lhwnd);
void DI_term(void);
HRESULT DI_keysin(void);
HRESULT DID_init(int dev);
void DID_term(int dev);


#endif