/*
Network.h

Version 1.0
(c)2001 Ben Woodhouse
Winsock 2.2 Network-play capability
*/


#ifndef networkH
#define networkH

#define NW_CLIENT 0
#define NW_SERVER 1

#define CMD_CHAT 0				//(BYTE player BYTE len, char[len])
#define CMD_SETID 1				//(BYTE id)
#define CMD_KEEPALIVE 2			//(void)


//#define CMD_PLAYERMOVE 4	//BYTE id, BYTE axis, float amt
//#define CMD_PLAYERROT 5	//BYTE id, BYTE axis, float amt

#define NW_MAXCLIENTS 8

#include "LinkedList.h"




//commands
int cmd_chat(SOCKET s,BYTE player, BYTE toPlayers, char * str); //len is worked out in func
int cmd_setID(SOCKET s,BYTE id);
int cmd_keepAlive(SOCKET s);


int getCmdType(SOCKET s);




void floatToBytes(float f, char b[4]);
int floatsToBytes(float * f,char * b, int numFloats); //returns num bytes copied
int bytesToFloats(char * b, float * f, int numFloats);
float bytesToFloat(char b[4]);
void getAddressByName(char * name, char * ipOut);
void getHostAddress(char * ipOut);

/*
class CThreeDegrees;
class CSpaceship;
*/


/*
struct CNetCommand
{
	int receive(SOCKET s);
	int send(SOCKET s);
	void print(bool msgbox=false);
	void set(BYTE c,BYTE i,float f1, float f2, float f3);

	BYTE command;
	BYTE iParam;
	float fParam[3];
};
*/
/*
class CNetInterface
{
	public:
		virtual int NW_write(char * outBuf, DWORD flags);
		virtual int NW_read(char * outBuf, DWORD flags);
};
*/
struct CWinsockInit  //class to initialise winsock
{
 
	CWinsockInit();
	~CWinsockInit();
};
extern CWinsockInit wsInit;


/*
class CNetPlayer
{
	public:
		char    name[10];  // name of player
};

*/

class CNetwork //a network object (server or client)
{
	public:
		virtual void init(){}
		virtual void handleMsg(WPARAM wParam,LPARAM lParam){}
		SOCKET sock;
}; //a client or server object





//puts the last winsock error into a message box
void translateError(int errorCode=-1);

//use whichever is necessary
extern CNetwork * networkp;


#include "NetClient.h"

#endif
