/*
GL Extension management system


(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 

*/
// Extensions.cpp: 
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

CExtensions extensions;

//////////////////////////////////////////////////////////////////////////////////
//
//							Function pointers 
//
//////////////////////////////////////////////////////////////////////////////////
//compiled vertex array 
PFNGLLOCKARRAYSEXTPROC glLockArraysEXT=NULL;
PFNGLUNLOCKARRAYSEXTPROC glUnlockArraysEXT=NULL;

//NV_Register_combiners_arb
PFNGLCOMBINERPARAMETERFVNVPROC glCombinerParameterfvNV=NULL;
PFNGLCOMBINERPARAMETERFNVPROC glCombinerParameterfNV=NULL;
PFNGLCOMBINERPARAMETERIVNVPROC glCombinerParameterivNV=NULL;
PFNGLCOMBINERPARAMETERINVPROC glCombinerParameteriNV=NULL;
PFNGLCOMBINERINPUTNVPROC glCombinerInputNV=NULL;
PFNGLCOMBINEROUTPUTNVPROC glCombinerOutputNV=NULL;
PFNGLFINALCOMBINERINPUTNVPROC glFinalCombinerInputNV=NULL; 
PFNGLGETCOMBINERINPUTPARAMETERFVNVPROC glGetCombinerInputParameterfvNV=NULL; 
PFNGLGETCOMBINERINPUTPARAMETERIVNVPROC glGetCombinerInputParameterivNV=NULL; 
PFNGLGETCOMBINEROUTPUTPARAMETERFVNVPROC glGetCombinerOutputParameterfvNV=NULL;
PFNGLGETCOMBINEROUTPUTPARAMETERIVNVPROC glGetCombinerOutputParameterivNV=NULL;
PFNGLGETFINALCOMBINERINPUTPARAMETERFVNVPROC glGetFinalCombinerInputParameterfvNV=NULL;
PFNGLGETFINALCOMBINERINPUTPARAMETERIVNVPROC glGetFinalCombinerInputParameterivNV=NULL;

//multitexture
PFNGLMULTITEXCOORD1DARBPROC		glMultiTexCoord1dARB = NULL;
PFNGLMULTITEXCOORD1DVARBPROC	glMultiTexCoord1dvARB = NULL;	
PFNGLMULTITEXCOORD1FARBPROC		glMultiTexCoord1fARB = NULL;
PFNGLMULTITEXCOORD1FVARBPROC	glMultiTexCoord1fvARB = NULL;
PFNGLMULTITEXCOORD1IARBPROC		glMultiTexCoord1iARB = NULL;
PFNGLMULTITEXCOORD1IVARBPROC	glMultiTexCoord1ivARB = NULL;	
PFNGLMULTITEXCOORD1SARBPROC		glMultiTexCoord1sARB = NULL;
PFNGLMULTITEXCOORD1SVARBPROC	glMultiTexCoord1svARB = NULL;
PFNGLMULTITEXCOORD2DARBPROC		glMultiTexCoord2dARB = NULL;
PFNGLMULTITEXCOORD2DVARBPROC	glMultiTexCoord2dvARB = NULL;	
PFNGLMULTITEXCOORD2FARBPROC		glMultiTexCoord2fARB = NULL;
PFNGLMULTITEXCOORD2FVARBPROC	glMultiTexCoord2fvARB = NULL;
PFNGLMULTITEXCOORD2IARBPROC		glMultiTexCoord2iARB = NULL;
PFNGLMULTITEXCOORD2IVARBPROC	glMultiTexCoord2ivARB = NULL;
PFNGLMULTITEXCOORD2SARBPROC		glMultiTexCoord2sARB = NULL;
PFNGLMULTITEXCOORD2SVARBPROC	glMultiTexCoord2svARB = NULL;
PFNGLMULTITEXCOORD3DARBPROC		glMultiTexCoord3dARB = NULL;
PFNGLMULTITEXCOORD3DVARBPROC	glMultiTexCoord3dvARB = NULL;
PFNGLMULTITEXCOORD3FARBPROC		glMultiTexCoord3fARB = NULL;
PFNGLMULTITEXCOORD3FVARBPROC	glMultiTexCoord3fvARB = NULL;
PFNGLMULTITEXCOORD3IARBPROC		glMultiTexCoord3iARB = NULL;
PFNGLMULTITEXCOORD3IVARBPROC	glMultiTexCoord3ivARB = NULL;
PFNGLMULTITEXCOORD3SARBPROC		glMultiTexCoord3sARB = NULL;
PFNGLMULTITEXCOORD3SVARBPROC	glMultiTexCoord3svARB = NULL;
PFNGLMULTITEXCOORD4DARBPROC		glMultiTexCoord4dARB = NULL;
PFNGLMULTITEXCOORD4DVARBPROC	glMultiTexCoord4dvARB = NULL;	
PFNGLMULTITEXCOORD4FARBPROC		glMultiTexCoord4fARB = NULL;
PFNGLMULTITEXCOORD4FVARBPROC	glMultiTexCoord4fvARB = NULL;
PFNGLMULTITEXCOORD4IARBPROC		glMultiTexCoord4iARB = NULL;
PFNGLMULTITEXCOORD4IVARBPROC	glMultiTexCoord4ivARB = NULL; 
PFNGLMULTITEXCOORD4SARBPROC		glMultiTexCoord4sdARB = NULL;
PFNGLMULTITEXCOORD4SVARBPROC	glMultiTexCoord4svARB = NULL;
PFNGLACTIVETEXTUREARBPROC		glActiveTextureARB = NULL;
PFNGLCLIENTACTIVETEXTUREARBPROC	glClientActiveTextureARB = NULL;	

//secondarycolor
PFNGLSECONDARYCOLOR3BEXTPROC glSecondaryColor3bEXT = NULL;
PFNGLSECONDARYCOLOR3BVEXTPROC glSecondaryColor3bvEXT = NULL;
PFNGLSECONDARYCOLOR3DEXTPROC glSecondaryColor3dEXT = NULL;
PFNGLSECONDARYCOLOR3DVEXTPROC glSecondaryColor3dvEXT = NULL;
PFNGLSECONDARYCOLOR3FEXTPROC glSecondaryColor3fEXT = NULL;
PFNGLSECONDARYCOLOR3FVEXTPROC glSecondaryColor3fvEXT = NULL ;
PFNGLSECONDARYCOLOR3IEXTPROC glSecondaryColor3iEXT = NULL;
PFNGLSECONDARYCOLOR3IVEXTPROC glSecondaryColor3ivEXT = NULL;
PFNGLSECONDARYCOLOR3SEXTPROC glSecondaryColor3sEXT = NULL;
PFNGLSECONDARYCOLOR3SVEXTPROC glSecondaryColor3svEXT = NULL;
PFNGLSECONDARYCOLOR3UBEXTPROC glSecondaryColor3ubEXT = NULL;
PFNGLSECONDARYCOLOR3UBVEXTPROC glSecondaryColor3ubvEXT = NULL;
PFNGLSECONDARYCOLOR3UIEXTPROC glSecondaryColor3uiEXT = NULL;
PFNGLSECONDARYCOLOR3UIVEXTPROC glSecondaryColor3uivEXT = NULL;
PFNGLSECONDARYCOLOR3USEXTPROC glSecondaryColor3usEXT = NULL;
PFNGLSECONDARYCOLOR3USVEXTPROC glSecondaryColor3usvEXT = NULL;
PFNGLSECONDARYCOLORPOINTEREXTPROC glSecondaryColorPointerEXT = NULL;

CExtensions::CExtensions()
{
	extensionNames=NULL;

}

CExtensions::~CExtensions()
{
	if (extensionNames!=NULL) delete [] extensionNames;
}

//////////////////////////////////////////////////////////////////////////////////
//
//							Calls to linker functions go here
//
//////////////////////////////////////////////////////////////////////////////////
void CExtensions::linkFunctions() 
{
	initNV_register_combiners();
	initARB_multitexture();
	initEXT_secondary_color();
	initEXT_compiled_vertex_array();
}

//////////////////////////////////////////////////////////////////////////////////
//
//							Extension Linker functions
//
//////////////////////////////////////////////////////////////////////////////////
bool CExtensions::initNV_register_combiners()
{
	if (extensions.exists("GL_NV_register_combiners"))
	{
		//nv register combiner extension
		glCombinerParameterfvNV= (PFNGLCOMBINERPARAMETERFVNVPROC) wglGetProcAddress("glCombinerParameterfvNV");
		glCombinerParameterfNV= (PFNGLCOMBINERPARAMETERFNVPROC) wglGetProcAddress("glCombinerParameterfNV");
		glCombinerParameterivNV= (PFNGLCOMBINERPARAMETERIVNVPROC) wglGetProcAddress("glCombinerParameterivNV");
		glCombinerParameteriNV=(PFNGLCOMBINERPARAMETERINVPROC) wglGetProcAddress("glCombinerParameteriNV");
		glCombinerInputNV= (PFNGLCOMBINERINPUTNVPROC) wglGetProcAddress("glCombinerInputNV");

		glCombinerOutputNV= (PFNGLCOMBINEROUTPUTNVPROC) wglGetProcAddress("glCombinerOutputNV");
		glFinalCombinerInputNV= (PFNGLFINALCOMBINERINPUTNVPROC) wglGetProcAddress("glFinalCombinerInputNV");
		glGetCombinerInputParameterfvNV= (PFNGLGETCOMBINERINPUTPARAMETERFVNVPROC) wglGetProcAddress("glGetCombinerInputParameterfvNV");
		glGetCombinerInputParameterivNV= (PFNGLGETCOMBINERINPUTPARAMETERIVNVPROC) wglGetProcAddress("glGetCombinerInputParameterivNV");
		glGetCombinerOutputParameterfvNV= (PFNGLGETCOMBINEROUTPUTPARAMETERFVNVPROC) wglGetProcAddress("glGetCombinerOutputParameterfvNV");
		glGetCombinerOutputParameterivNV= (PFNGLGETCOMBINEROUTPUTPARAMETERIVNVPROC) wglGetProcAddress("glGetCombinerOutputParameterivNV");
		glGetFinalCombinerInputParameterfvNV= (PFNGLGETFINALCOMBINERINPUTPARAMETERFVNVPROC) wglGetProcAddress("glGetFinalCombinerInputParameterfvNV");
		glGetFinalCombinerInputParameterivNV= (PFNGLGETFINALCOMBINERINPUTPARAMETERIVNVPROC) wglGetProcAddress("glGetFinalCombinerInputParameterivNV");
		return true;
	}
	return false;
}

bool CExtensions::initARB_multitexture()
{
	if (extensions.exists("GL_ARB_multitexture"))
	{
		glMultiTexCoord1dARB	= (PFNGLMULTITEXCOORD1DARBPROC)		wglGetProcAddress("glMultiTexCoord1dEXT");
		glMultiTexCoord1dvARB	= (PFNGLMULTITEXCOORD1DVARBPROC)	wglGetProcAddress("glMultiTexCoord1dvARB");	
		glMultiTexCoord1fARB	= (PFNGLMULTITEXCOORD1FARBPROC)		wglGetProcAddress("glMultiTexCoord1fARB");
		glMultiTexCoord1fvARB	= (PFNGLMULTITEXCOORD1FVARBPROC)	wglGetProcAddress("glMultiTexCoord1fvARB");
		glMultiTexCoord1iARB	= (PFNGLMULTITEXCOORD1IARBPROC)		wglGetProcAddress("glMultiTexCoord1iARB");
		glMultiTexCoord1ivARB	= (PFNGLMULTITEXCOORD1IVARBPROC)	wglGetProcAddress("glMultiTexCoord1ivARB");
		glMultiTexCoord1sARB	= (PFNGLMULTITEXCOORD1SARBPROC)		wglGetProcAddress("glMultiTexCoord1sARB");
		glMultiTexCoord1svARB	= (PFNGLMULTITEXCOORD1SVARBPROC)	wglGetProcAddress("glMultiTexCoord1svARB");
		glMultiTexCoord2dARB	= (PFNGLMULTITEXCOORD2DARBPROC)		wglGetProcAddress("glMultiTexCoord2dARB");
		glMultiTexCoord2dvARB	= (PFNGLMULTITEXCOORD2DVARBPROC)	wglGetProcAddress("glMultiTexCoord2dvARB");	
		glMultiTexCoord2fARB	= (PFNGLMULTITEXCOORD2FARBPROC)		wglGetProcAddress("glMultiTexCoord2fARB");
		glMultiTexCoord2fvARB	= (PFNGLMULTITEXCOORD2FVARBPROC)	wglGetProcAddress("glMultiTexCoord2fvARB");
		glMultiTexCoord2iARB	= (PFNGLMULTITEXCOORD2IARBPROC)		wglGetProcAddress("glMultiTexCoord2iARB");
		glMultiTexCoord2ivARB	= (PFNGLMULTITEXCOORD2IVARBPROC)	wglGetProcAddress("glMultiTexCoord2ivARB");
		glMultiTexCoord2sARB	= (PFNGLMULTITEXCOORD2SARBPROC)		wglGetProcAddress("glMultiTexCoord2sARB");
		glMultiTexCoord2svARB	= (PFNGLMULTITEXCOORD2SVARBPROC)	wglGetProcAddress("glMultiTexCoord2svARB");
		glMultiTexCoord3dARB	= (PFNGLMULTITEXCOORD3DARBPROC)		wglGetProcAddress("glMultiTexCoord3dARB");
		glMultiTexCoord3dvARB	= (PFNGLMULTITEXCOORD3DVARBPROC)	wglGetProcAddress("glMultiTexCoord3dvARB");
		glMultiTexCoord3fARB	= (PFNGLMULTITEXCOORD3FARBPROC)		wglGetProcAddress("glMultiTexCoord3fARB");
		glMultiTexCoord3fvARB	= (PFNGLMULTITEXCOORD3FVARBPROC)	wglGetProcAddress("glMultiTexCoord3fvARB");
		glMultiTexCoord3iARB	= (PFNGLMULTITEXCOORD3IARBPROC)		wglGetProcAddress("glMultiTexCoord3iARB");
		glMultiTexCoord3ivARB	= (PFNGLMULTITEXCOORD3IVARBPROC)	wglGetProcAddress("glMultiTexCoord3ivARB");
		glMultiTexCoord3sARB	= (PFNGLMULTITEXCOORD3SARBPROC)		wglGetProcAddress("glMultiTexCoord3sARB");
		glMultiTexCoord3svARB	= (PFNGLMULTITEXCOORD3SVARBPROC)	wglGetProcAddress("glMultiTexCoord3svARB");
		glMultiTexCoord4dARB	= (PFNGLMULTITEXCOORD4DARBPROC)		wglGetProcAddress("glMultiTexCoord4dARB");
		glMultiTexCoord4dvARB	= (PFNGLMULTITEXCOORD4DVARBPROC)	wglGetProcAddress("glMultiTexCoord4dvARB");	
		glMultiTexCoord4fARB	= (PFNGLMULTITEXCOORD4FARBPROC)		wglGetProcAddress("glMultiTexCoord4fARB");
		glMultiTexCoord4fvARB	= (PFNGLMULTITEXCOORD4FVARBPROC)	wglGetProcAddress("glMultiTexCoord4fvARB");
		glMultiTexCoord4iARB	= (PFNGLMULTITEXCOORD4IARBPROC)		wglGetProcAddress("glMultiTexCoord4iARB");
		glMultiTexCoord4ivARB	= (PFNGLMULTITEXCOORD4IVARBPROC)	wglGetProcAddress("glMultiTexCoord4ivARB");
		glMultiTexCoord4sdARB	= (PFNGLMULTITEXCOORD4SARBPROC)		wglGetProcAddress("glMultiTexCoord4sdARB");
		glMultiTexCoord4svARB	= (PFNGLMULTITEXCOORD4SVARBPROC)	wglGetProcAddress("glMultiTexCoord4svARB");
		glActiveTextureARB		= (PFNGLACTIVETEXTUREARBPROC)		wglGetProcAddress("glActiveTextureARB");
		glClientActiveTextureARB= (PFNGLCLIENTACTIVETEXTUREARBPROC)	wglGetProcAddress("glClientActiveTextureARB");
		return true;
	}
	return false;
}

bool CExtensions::initEXT_secondary_color()
{
	if (extensions.exists("GL_EXT_secondary_color"))
	{
		glSecondaryColor3fEXT = (PFNGLSECONDARYCOLOR3FEXTPROC) wglGetProcAddress("glSecondaryColor3fEXT");
		glSecondaryColor3fvEXT = (PFNGLSECONDARYCOLOR3FVEXTPROC) wglGetProcAddress("glSecondaryColor3fvEXT");

		return true;
	}
	return false;
}

bool CExtensions::initEXT_compiled_vertex_array()
{
	if (extensions.exists("GL_EXT_compiled_vertex_array"))
	{
		glLockArraysEXT=(PFNGLLOCKARRAYSEXTPROC)wglGetProcAddress("glLockArraysEXT");
		glUnlockArraysEXT=(PFNGLUNLOCKARRAYSEXTPROC)wglGetProcAddress("glUnlockArraysEXT");;
		return true;
	}
	return false;
}

void CExtensions::getNames()
{
	char * extStr=(char *)glGetString(GL_EXTENSIONS);
	char extensionName[1024];
	int a,b;

	numExtensions=0;

	//generate the right number of extensions
	for (a=0;extStr[a]!=NULL;++a)
	{
		if (extStr[a]==' ')
			++numExtensions;
	}


	
	extensionNames=new std::string[numExtensions];
//	messageBox("NumExtensions: %d",numExtensions);

	int eNum=0;

	a=0;

	while (extStr[a]!=NULL)
	{
		b=0;
		while (extStr[a]!=' ' && extStr[a]!=NULL)
		{
			extensionName[b]=extStr[a];
			++b;
			++a;
		}
		extensionName[b]=NULL;
		//CString
		//extensionNames[eNum].setName(extensionName);
		extensionNames[eNum]=extensionName;
//		messageBox(extensionName);
		++eNum;
		++a; 
	}

}


bool CExtensions::exists(const std::string & name)
{
	bool rv=false;

	//search for the extension
	//for (int a=0;a<numExtensions;++a)
	for (int a=0;a<numExtensions;++a)
	{
		//if (strcmp(name,extensions[a].getName())==0)
		if (name==extensionNames[a])
		{
			rv=true;
			break;
		}

	}
	return rv;
}

void CExtensions::display()
{
	for (int a=0;a<numExtensions;++a)
	{
		glPrintf(extensionNames[a]+"\n");
	}
}



