// FloodSpell.h: interface for the FloodSpell class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FLOODSPELL_H__10B70675_3E91_4E68_B42A_1790FA280C03__INCLUDED_)
#define AFX_FLOODSPELL_H__10B70675_3E91_4E68_B42A_1790FA280C03__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Spell.h"
#include "ParticleRain.h"
#include "Sound.h"

class FloodSpell : public Spell  
{
public:
	FloodSpell();
	virtual ~FloodSpell();
	void doStuff();
	void deleteSelf(){delete this;}


protected:
	ParticleRain * rain;
	double timer;
	Sound thunderSound;
	Sound rainSound;
	Sound seaSound;
};

#endif // !defined(AFX_FLOODSPELL_H__10B70675_3E91_4E68_B42A_1790FA280C03__INCLUDED_)
