// Font.h: interface for the Font class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FONT_H__83BD97AB_25E8_469C_B53D_882D57291D8E__INCLUDED_)
#define AFX_FONT_H__83BD97AB_25E8_469C_B53D_882D57291D8E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct Letter
{
	BYTE width;
	float texCoordx[2];
	float texCoordy[2];
	float texCoordWidth;
};

class Font
{
	public:
		Font();
		virtual ~Font();
		void setSize(int sizeX_in,int sizeY_in);
		void setColour(float r,float g, float b);
		void setTexP(CTexture * tex_in);
		void setResolution(int x, int y);
		void setAlternate(bool alt);
		bool getAlternate(){return alternate;}

		bool load(const char * texFilename, const char * sizeFilename);
		//void calculateWidths(CImage & fontImage);


		int resX;
		int resY;


		float sizeX;
		float sizeY;

//		int spaceX;
//		int spaceY;
		CTexture * tex;

		Letter letter[256];
		float colour[3];

		BYTE height;
		float texCoordHeight;
		int charOffset;

	private:
		bool alternate;
}; //formatted fonts (outtext type)

#endif // !defined(AFX_FONT_H__83BD97AB_25E8_469C_B53D_882D57291D8E__INCLUDED_)
