// GameInfoDisplay.h: interface for the GameInfoDisplay class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAMEINFODISPLAY_H__AEECF7C1_CFFD_48A9_9D59_2578D384173B__INCLUDED_)
#define AFX_GAMEINFODISPLAY_H__AEECF7C1_CFFD_48A9_9D59_2578D384173B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "wizard.h"

class GameInfoDisplay  
{
public:
	GameInfoDisplay();
	virtual ~GameInfoDisplay();
	void draw2DRect(int top, int right, int bottom, int left);
	void display(Wizard * wizards, int userWizardNo, int score[2]);
	void drawHealthBar();
	void drawEnergyBar(	int left, 
						int bottom, 
						int width, 
						int height, 
						float full, 
						float cola[4],
						float colb[4]);

	void GameInfoDisplay::drawSpell(int left, 
									int bottom,
									CTexture * tex,
									float power,
									bool selected);
	void GameInfoDisplay::drawSpells(int selection ,Wizard * userWizard);


	void loadTextures();
	CTexture * loadTexAlpha(const char * fn, CImage & alpha);
private:
	CTexture * redHealthTex;
	CTexture * blueHealthTex;
	CTexture * fireTex;
	CTexture * waterTex;
	CTexture * airTex;
	CTexture * earthTex;
};

#endif // !defined(AFX_GAMEINFODISPLAY_H__AEECF7C1_CFFD_48A9_9D59_2578D384173B__INCLUDED_)
