// Image_BMPHeader.h: interface for the Image_BMPHeader class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_IMAGE_BMPHEADER_H__141D0A10_7807_4B02_AD43_534BBE1A0451__INCLUDED_)
#define AFX_IMAGE_BMPHEADER_H__141D0A10_7807_4B02_AD43_534BBE1A0451__INCLUDED_

struct BMPHeader
{
	BMPHeader(){}
	BMPHeader(unsigned int width_in, unsigned int height_in, unsigned int numChannels);
	void writeToFile(FILE * f);
	void readFromFile(FILE * f);
	int getAlignBytes();

	unsigned char id[2];
	unsigned int filesize; //set
	unsigned int reserved; 
	unsigned int dataOffset; 
	unsigned int headerSize; 
	unsigned int width;     //set
	unsigned int height;    //set
	unsigned short planes;
	unsigned short bpp;    //set
	unsigned int compression;
	unsigned int bitmapDataSize; //set
	unsigned int hResPerMetre;
	unsigned int vResPerMetre;
	unsigned int colours;  //set
	unsigned int importantColours; //set
};

#endif // !defined(AFX_IMAGE_BMPHEADER_H__141D0A10_7807_4B02_AD43_534BBE1A0451__INCLUDED_)
