// Intro.h: interface for the Intro class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INTRO_H__D468B8CD_BA14_4114_AD20_C4E106D83B7A__INCLUDED_)
#define AFX_INTRO_H__D468B8CD_BA14_4114_AD20_C4E106D83B7A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



class Intro  
{
public:
	Intro();
	virtual ~Intro();
	void draw();
	void mainLoop();
	void backToGame();
	void init();
	
	void slideEvent(int slideNo, 
				    float begin, 
				    float middle, 
				    float end, 
				    float sustain, 
				    float startBright, 
					float midBright, 
					float endBright);

	void fadeEvent(	float begin, 
					float middle, 
					float end, 
					float sustain,
					float startBright, 
					float midBright, 
					float endBright);

	float getEventBrightness(float begin, 
							float middle, 
							float end, 
							float sustain,
							float startBright, 
							float midBright, 
							float endBright);

protected:
	double timer,oldTimer;
	void drawFader(float bright);
	void showSlide(float bright);
	bool firstInit;
	float bright;

	CTexture * slideshow[4];
};

#endif // !defined(AFX_INTRO_H__D468B8CD_BA14_4114_AD20_C4E106D83B7A__INCLUDED_)
