// LightManager.h: interface for the LightManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LIGHTMANAGER_H__B3D736E7_E8AE_4E80_83D5_2D24817AC400__INCLUDED_)
#define AFX_LIGHTMANAGER_H__B3D736E7_E8AE_4E80_83D5_2D24817AC400__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Light.h"

#define MAX_LIGHTS 3

class LightManager  
{
public:
	LightManager();
	virtual ~LightManager();
	
	void specifyAll();

	Light * createLight(float pos[3], float red, float green, float blue);
	void destroyLight(Light * lite);
	Light * getLight(int num){return &lights[num];}

	Light lights[MAX_LIGHTS];
	int numLights;
};

#endif // !defined(AFX_LIGHTMANAGER_H__B3D736E7_E8AE_4E80_83D5_2D24817AC400__INCLUDED_)
