// Music.h: interface for the CMusic class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MUSIC_H__60ACD38A_9AEF_4381_863A_DC8088603698__INCLUDED_)
#define AFX_MUSIC_H__60ACD38A_9AEF_4381_863A_DC8088603698__INCLUDED_


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class Music
{ 
public:
	Music();
	virtual ~Music();
//	bool init();
	bool init(LPDIRECTSOUND *pDSound);
	IDirectMusicPerformance8 *getPerformance(){return pPerf;}
	//IDirectMusicLoader8 *getMusicLoader(){return pMusicLoader;}
	//IDirectMusicLoader8 *getWaveLoader(){return pWaveLoader;}
	IDirectMusicSegment8 *loadNewSound(const char * fn);
	IDirectMusicSegment8 *loadNewMusic(const char * fn);

	void setVolume(float vol);
	float getVolume(){return volume;}
	void uninit();

protected:
	float volume;
	void addNewSegment(IDirectMusicSegment8 * seg);
	void releaseSegments();
	int numSegments;
	IDirectMusicPerformance8 *pPerf;
	IDirectMusicLoader8 *pMusicLoader;
	std::vector<IDirectMusicSegment *>pSegments;
};

extern Music music;

#endif // !defined(AFX_MUSIC_H__60ACD38A_9AEF_4381_863A_DC8088603698__INCLUDED_)
