// NetClient.h: interface for the NetClient class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NETCLIENT_H__AB3892E6_DB8D_4E83_A411_A79D51C5BE20__INCLUDED_)
#define AFX_NETCLIENT_H__AB3892E6_DB8D_4E83_A411_A79D51C5BE20__INCLUDED_


#define CMD_DISCONNECT 9
#include "network.h"

class NetClient
{
	public:
		NetClient();
		//void init(bool host);
		void handleMsg(WPARAM wParam,LPARAM lParam);
		virtual void readCommand(SOCKET sock){}
		void handleMulticastMsg(WPARAM wParam,LPARAM lParam);
		bool startMulticastIP();
		SOCKET getSock(){return sock;}
		void shutdown();
		void sendMulticastIP();

		char id;
		bool debug;

	protected:
		bool opened;
		int port;
		char addr[14];
		bool host;
		ip_mreq mreq;
		char TTL; // Restrict to region
		SOCKADDR_IN  addrDest;

		sockaddr_in target;
		SOCKET sock;
		bool connected;
};




#endif // !defined(AFX_NETCLIENT_H__AB3892E6_DB8D_4E83_A411_A79D51C5BE20__INCLUDED_)
