// NetServer.h: interface for the NetServer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NETSERVER_H__114B7405_A703_4D9E_B227_EBC5A28286D8__INCLUDED_)
#define AFX_NETSERVER_H__114B7405_A703_4D9E_B227_EBC5A28286D8__INCLUDED_





struct CClientSock
{
	CClientSock()
	{
		inuse=false;
	}
	bool inuse;
	SOCKET sock;
	sockaddr_in sockaddr;
};





class NetServer:public CNetwork
{

	public:
		NetServer();
		void init(SOCKET * pClientSock);
		bool bindSocket(u_short port);
		bool waitForClients();
		bool acceptConnection();
		void handleMsg(WPARAM wParam,LPARAM lParam);
		void handleMulticastMsg(WPARAM wParam,LPARAM lParam);

		virtual void readCommand(SOCKET sock){} //override this

		int connectSelf(SOCKET * pClientSock);

		void startMulticastIP();
		void endMulticastIP();
		void sendMulticastIP();

		bool open;
	protected:
		ip_mreq mreq;
		char TTL; // Restrict to region
		bool bBroadcast;
		SOCKADDR_IN  addrDest;
		//		SOCKET self;
		//void addPlayer(char * name);
		//bool deletePlayer();

		
//		CLinkedList <CNetPlayer> playerList; //the player list
//		SOCKET listenSocket; //server's client socket
		//SOCKET self; //server's client socket
		SOCKADDR_IN ipAddress;
		SOCKET ipBroadcastSock;

		CClientSock client[NW_MAXCLIENTS];
};








#endif // !defined(AFX_NETSERVER_H__114B7405_A703_4D9E_B227_EBC5A28286D8__INCLUDED_)
