// ParticleRain.h: interface for the ParticleRain class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARTICLERAIN_H__080A09D2_0505_4987_8EA6_63994BBE3DBD__INCLUDED_)
#define AFX_PARTICLERAIN_H__080A09D2_0505_4987_8EA6_63994BBE3DBD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ParticleSystem.h"

class ParticleRain : public ParticleSystem  
{
public:
	ParticleRain(float partsPerSec);
	virtual ~ParticleRain();

	void postMove();
	void preDraw();

	//virtual void start(){}
	void stop();
	void makeParticle(Particle & part);
	bool isDead();

	bool active;

protected:
	float partsPerSec;
	float timeOffset;

};

#endif // !defined(AFX_PARTICLERAIN_H__080A09D2_0505_4987_8EA6_63994BBE3DBD__INCLUDED_)
