#ifndef PARTICLETYPE_H
#define PARTICLETYPE_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "particle1.h"


struct PT_Smoke: public ParticleType
{
	void generate(Particle * part);
}; 

struct PT_Fire: public ParticleType
{
	void generate(Particle * part);
};

struct PT_Sparks: public ParticleType
{
	PT_Sparks(){eforce=1;}
	PT_Sparks(float eforce,bool hemisphere)
	{
		this->eforce=eforce;
		this->hemisphere=hemisphere;
	};

	void generate(Particle * part);
	float eforce;
	bool hemisphere;
};

struct PT_Static: public ParticleType
{
	void generate(Particle * part);
};



#endif