// QuicksandSpell.h: interface for the QuicksandSpell class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QUICKSANDSPELL_H__79B7AB76_4357_4674_AE74_C2CFEB349C10__INCLUDED_)
#define AFX_QUICKSANDSPELL_H__79B7AB76_4357_4674_AE74_C2CFEB349C10__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Spell.h"
#include "Wizard.h"

class QuicksandSpell : public Spell  
{
public:
	QuicksandSpell(){}
	QuicksandSpell(float target[3], Wizard * caster, Wizard * enemy);
	~QuicksandSpell();
	void doStuff();
	void draw();
	void deleteSelf(){delete this;}


protected:
	void sinkWizards();

	float pos[3];
	double timer;
	int alphaID;
	Wizard *wizards[2];
	bool wizSinking[2];
	Sound sinkSound[2];


};

#endif // !defined(AFX_QUICKSANDSPELL_H__79B7AB76_4357_4674_AE74_C2CFEB349C10__INCLUDED_)
