/*
Debuglog.h

v1.11

(c)2001 Ben Woodhouse
*/

#ifndef debugLogH
#define debugLogH

#include <stdio.h>
#include <time.h>
#include <stdarg.h>
#include <string.h>

void dateToString(char * stringp); //converts date in proper format

class debugLog_c
{
	public:
		debugLog_c(char * fn);
		~debugLog_c();
		void write(const char *format, ...); //takes same format as printf
        void update(); //updates the log without having to exit
	protected:
		FILE * file;
        char * filename;
};

#endif

