/*
gamemode.cpp

Version 1.21

(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 

*/



#include "stdafx.h"

//GLOBALS

gameMode * gameModeCP=NULL;
gameMode * changeToMode=NULL;

//call at beginning of main loop
void newMode_check(void)
{
	if (changeToMode!=NULL)
	{
		if (gameModeCP!=NULL)
		{
			gameModeCP->shutdown();
		}
		gameModeCP=changeToMode;
		gameModeCP->init();

		changeToMode=NULL;
	}
}

//tells the engine to change mode at the end of the main loop
void changeMode(gameMode * newMode)
{
	changeToMode=newMode;
}

void doFunc(void)
{
	if (currentMenu!=NULL)
		currentMenu->KeysIn();

	else
	{
		if (gameModeCP!=NULL)
		{
			gameModeCP->mainLoop();
		}
	}
}

void drawFunc(void)
{
	if (gameModeCP!=NULL)
	{
		gameModeCP->draw();
	}

	if (currentMenu!=NULL)
		currentMenu->display();
}
