/*
MainMenu.cpp

events and initialization for the main menu of Dauntless

(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/

#include "stdafx.h"
#include "dauntless.h"

CMainMenu mainMenu;

CMainMenu::CMainMenu()
{
	setTitle("Main Menu");
	addItem(	"Single Player ",MENU_THING,&mm_singlePlayer); 
	addItem(	"Multiplayer   ",MENU_THING,&mm_multiplayer);

	addItem("Options           ",MENU_THING,&mm_options);
	//addItem("",MENU_DIVIDER); 
	addItem("Intro/Credits        ",MENU_THING,&mm_intro);
	addItem("Help",MENU_THING,&mm_help);
	addItem("",MENU_DIVIDER); 
	addItem("QUIT",MENU_THING,&mm_quitPressed);

}

void mm_singlePlayer(int blah)
{
	singlePlayerMenu.execute();
}

void mm_multiplayer(int blah)
{
	multiplayerMenu.execute();
}

void mm_quitPressed(int blah)
{
	if (client.isConnected())
	{
		client.disconnect();
		Sleep(250);
	}
	Quit=1;
}

void mm_options(int blah)
{
	optionsMenu.execute();
}
void mm_intro(int blah)
{
	mainGM.changeToMode(MODE_INTRO);
	mainMenu.exitMenus();
}
void mm_help(int blah)
{
	mainMenu.exitMenus();
	mainGM.setDisplayHelp(true);
//	helpMenu.execute();
//	glCls();
}

/*
void hello2Update(int valueIn)
{
	//blah
}*/




