/*
splitscreen.h

version 1.01
*/

//decide what needs to be taken out of global (resize? renderVP?)
//and what needs to go in viewport (aspect etc)

class CScreen
{
	public:
		CScreen();

		void splitScreen(BOOL ssb); //call with TRUE to split the screen or FALSE to unsplit

		//call instead of renderall
		void render(); //replaces ::renderVP?

		void setVP3Deg(CThreeDegrees * threeDeg_src, ThreeDegreesCamera * vp_dst);
//		void setVP(int num, Viewport * vp_in);

		void resize(GLsizei width, GLsizei height);

		void brightnessOverlay();
		void push2D();
		void pop2D();
		void update(); //refreshes the display
		void setBrightness(float brightness_in){brightness=brightness_in;}
		void doFlasher();

		int numViewPorts;

		OrbitalCamera * vp[2];

		//the default camera
		OrbitalCamera defaultVP;

		GLsizei sizex;
		GLsizei sizey;
		GLsizei halfx;
		GLsizei halfy;

		float getFlasher(){return flasher;}
	protected:
		float brightness;

		float flasher;



};

extern CScreen screen;
